<?php
//TITLE=Adlib-S3M player for QuickBasic, with effects support

$title = 'Adlib-S3M player for QuickBasic, with effects support';
$progname = 'fmengineqb';

exec('egrep "^SUB|^FUNCTION" /home/bisqwit/src/fmengine/fmengine.bas|sort',$output);
$funs = array();
foreach($output as $fun)
  $funs[] = '<code>'.htmlspecialchars(ereg_replace('.* ','',ereg_replace(' \(.*', '', $fun))).'()</code>';
$funlist = '';
for($c=0; $c<count($funs); $c++)
{
  if($c==count($funs)-1)$funlist .= ' and ';
  elseif($c > 0)$funlist .= ', ';
  $funlist .= $funs[$c];
}

$text = array(
   '1. Purpose' => "

Some entirely in QuickBasic written subroutines for playing Adlib-S3M
or MidiS3M files in a QuickBasic program.

", '1. Neat features' => "

<ul>
 <li>+Does not require any difficult timing loops or calling a subroutine
      regularly. It works \"behind the scenes\".</li>
 <li>+Supports changing the song any time you want.</li>
 <li>+Uses really little memory.</li>
 <li>-It accesses your hard disk / floppy often: it loads and keeps only
      one pattern at time from the file to memory. You shouldn't notice
      this though if you're using a disk cache program like smartdrv).</li>
 <li>+Allows playing adlib sound effects on the top of music.
      The sound effects are actually music tracks.</li>
 <li>+Entirely written in QuickBasic.
      This does not require any assembler-written modules.</li>
 <li>+The following S3M effects and control codes are supported:<br>
      Axx, Txx, Dxx, Kxx, Exx, Fxx, Hxx, Cxx, Bxx, SBx, SCx, SDx, SEx</li>
 <li>+It supports MPU-401 (midi) playing also.</li>
 <li>+The subroutines are fairly easy to copy to your own program
      to add nice music.</li>
</ul>

", '1. Notes' => "

", '1.1. Example songs' => "

The archive contains four example songs and one example effect file.<br>
Two of the example songs are made by Future Crew, two by me.

", '1.1. Hazards' => "

The current version just assumes you have MPU-401 too. If you don't have,
just edit the <code>MPUwrite</code> subroutine and add a <code>EXIT&nbsp;SUB</code>
clause there to be the first command.

", '1.1. How does its timer handler work?' => "

It uses <code>ON&nbsp;PLAY</code> event mechanism for the timing,
and plays short silent pause commands. Therefore you can not make
speaker beeps while the player is playing. This does not affect
the performance of the main program.

", '1.1. If it does not play anything' => "

In the example program, you must press a key
(try \"b\", \"d\", \"e\" or \"f\") to start a song.<br>
However, in my laptop, it does not play anything. Weird.
Neither does <em>Scream&nbsp;Tracker</em> though.
I don't know why. Perhaps the sound card is not really
very compatible.

", '1.1. Memory usage' => "

The player uses following global static tables, and nothing else:<br>
<table border=1><tr><th>Var</th><th>Size in bytes</th><th>Type</th></tr>
<tr><td>fmperiod</td><td>24</td><td>int[0..11]</td></tr>
<tr><td>order</td><td>512</td><td>int[0..255]</td></tr>
<tr><td>adldata</td><td>2400</td><td>int[1..100,0..11]</td></tr>
<tr><td>insdata</td><td>1200</td><td>{6 ints}[1..100]</td></tr>
<tr><td>adlchan</td><td>896</td><td>{14 ints}[0..31]</td></tr>
<tr><td>MIDInote</td><td>64</td><td>int[0..31]</td></tr>
<tr><td>MIDIchan</td><td>64</td><td>int[0..31]</td></tr>
<tr><td>fmfilename</td><td>4+n</td><td>string</td></tr>
<tr><td>fmpattern</td><td>4+n</td><td>string</td></tr>
<tr><td>fmeffect</td><td>4+n</td><td>string</td></tr>
<tr><td>fmdata</td><td>44</td><td>{16 ints,double,long}</td></tr>
<tr><td>fmeff</td><td>24</td><td>{3 ints}[0..3]</td></tr>
<tr><td align=right>Total:</td><td>5240+n</td><td></td></tr>
</table>

", '1. Short example' => "

<code>
'\$INCLUDE: 'fmengine.bi'<br>
pleiplei: IF FMtimer% THEN RETURN<br>
IF FMinit < 0 THEN PRINT \"FM sound not available.\": END<br>
FMload \"mysidia.s3m\"<br>
' The main loop<br>
WHILE INKEY$ = \"\": WEND<br>
FMend<br>
END</code><br>
Could it any way be simpler than this?<br>
&nbsp;<br><small>
(Note you must copy $funlist to the program, but these do not bother your editing, do they? :)
)</small>

", '1. Copying' => "

fmengineqb has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.stc.cx/\">Bisqwit</a>,<br>
and is distributed under the following terms:
<blockquote><code>".
str_replace("\n",'<br>',htmlspecialchars(fread(fopen('/WWW/TINYFREELICENSE','r'),filesize('/WWW/TINYFREELICENSE')))).
"</code></blockquote>

");
include '/WWW/progdesc.php';
